// Fonctions pour les pseudo-"tiles" facilement utilisables grce au format de l'cran
// Created 28/12/2002; 19:46:18

// Ces fonctions ne prennent pas en compte la taille de l'cran.
// Elles marchent aussi bien sur TI 89 que sur la Voyage 200.
// Par contre, vu que l'cran des TI 89 est plus petit, les tiles
// au-del d'une certaine ligne et/ou colonne ne seront pas affichs
// sur les TI 89

#include <compat.h>
#define LCD_BUFF_BYTES 30

// Fonction pour afficher un bloc de 8x8 pixels  l'endroit voulu
// col et row sont la colonne et la ligne en partant de 0.
void scr_set_tile8(void *vm_addr, unsigned char *tile, unsigned char col, unsigned char row)
{
	unsigned char *ptr;
	unsigned char i;
	
	if ((col >= LCD_LINE_BYTES) || (row >= LCD_HEIGHT / 8))
		return;
	ptr = (unsigned char *)vm_addr + col + row * (8 * LCD_BUFF_BYTES);
	for (i = 0; i < 8; i++, ptr += LCD_BUFF_BYTES)
		poke(ptr, tile[i & 0x7]);
}

// Fonction pour afficher un bloc de 16x16 pixels  l'endroit voulu
// col et row sont la colonne et la ligne en partant de 0.
void scr_set_tile16(void *vm_addr, unsigned short *tile, unsigned char col, unsigned char row)
{
	unsigned char *ptr;
	unsigned char i;
	
	if ((col >= LCD_LINE_BYTES / 2) || (row >= LCD_HEIGHT / 16))
		return;
	ptr = (unsigned char *)vm_addr + (col << 1) + row * (16 * LCD_BUFF_BYTES);
	for (i = 0; i < 16; i++, ptr += LCD_BUFF_BYTES)
		poke_w(ptr, tile[i & 0xF]);
}

// Fonction de dessin des blocs de 8*8 pixels (prvue trs rapide en principe...)
// Pour remplir l'cran de "tiles" de 8x8 px
void scr_fill_tile8(void *vm_addr, unsigned char *tile)
{
	unsigned char *ptr;
	unsigned char i, j;
	
	ptr = (unsigned char *)vm_addr;
	for (i = 0; i < LCD_HEIGHT; i++)
		for (j = 0; j < LCD_LINE_BYTES; j++, ptr++)
			poke(ptr, tile[i & 0x7]);
}

// Fonction de dessin des blocs de 16*16 pixels (prvue trs rapide en principe...)
// Pour remplir l'cran de "tiles" de 16x16 px
void scr_fill_tile16(void *vm_addr, unsigned short *tile)
{
	unsigned char *ptr;
	unsigned char i, j;
	
	ptr = (unsigned char *)vm_addr;
	for (i = 0; i < LCD_HEIGHT; i++)
		for (j = 0; j < LCD_LINE_BYTES; j++, ptr += 2)
			poke_w(ptr, tile[i & 0xF]);
}